#include <windows.h>
#include <gl/gl.h>
#include <math.h>
#include <mmsystem.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#define PI 3.14159265358979323846


LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);
void EnableOpenGL(HWND hwnd, HDC*, HGLRC*);
void DisableOpenGL(HWND, HDC, HGLRC);


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
    WNDCLASSEX wcex;
    HWND hwnd;
    HDC hDC;
    HGLRC hRC;
    MSG msg;
    BOOL bQuit = FALSE;
    float theta = 0.0f;

    wcex.cbSize = sizeof(WNDCLASSEX);
    wcex.style = CS_OWNDC;
    wcex.lpfnWndProc = WindowProc;
    wcex.cbClsExtra = 0;
    wcex.cbWndExtra = 0;
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
    wcex.lpszMenuName = NULL;
    wcex.lpszClassName = "Esans";
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);;

    if (!RegisterClassEx(&wcex))
        return 0;




    int WINh = 1080;
    int WINw = 1920;
    char res;
    char prompt;

    printf("Paljonkos pannaan?: \n1 1920x1080 (Full Screen)\n2 1280x720(Full Screen)\n3 800x600(Full Screen)\n4 480x320(Full Screen)\n\n5 1920x1080(windowed)\n6 1280x720(windowed)\n7 800x600(windowed)\n8 480x320(windowed)\n");
    res = getchar();

    switch(res)
    {
    case '1' :
        WINw = 1920;
        WINh = 1080;
        prompt = 'y';
        break;
    case '2' :
        WINw = 1280;
        WINh = 720;
        prompt = 'y';
        break;
    case '3' :
        WINw = 800;
        WINh = 600;
        prompt = 'y';
        break;
    case '4' :
        WINw = 480;
        WINh = 320;
        prompt = 'y';
        break;
    case '5' :
        WINw = 1920;
        WINh = 1080;
        prompt = 'n';
        break;
    case '6' :
        WINw = 1280;
        WINh = 720;
        prompt = 'n';
        break;
    case '7' :
        WINw = 800;
        WINh = 600;
        prompt = 'n';
        break;
    case '8' :
        WINw = 480;
        WINh = 320;
        prompt = 'n';
        break;
    default :
        WINw = 1920;
        WINh = 1080;
        prompt = 'n';

    }

    if(prompt == 'y')
    {
        hwnd = CreateWindowEx(0,
                              "Esans",
                              "Esanssia",
                              WS_POPUP,
                              CW_USEDEFAULT,
                              CW_USEDEFAULT,
                              WINw,
                              WINh,
                              NULL,
                              NULL,
                              hInstance,
                              NULL);
        SetCapture(hwnd);
        SetCursor(0);


    }

    else
    {
        hwnd = CreateWindowEx(0,
                              "Esans",
                              "Esanssia",
                              WS_SYSMENU,
                              CW_USEDEFAULT,
                              CW_USEDEFAULT,
                              WINw,
                              WINh,
                              NULL,
                              NULL,
                              hInstance,
                              NULL);



    }
    ShowWindow(hwnd, nCmdShow);
    SetForegroundWindow(hwnd);



    EnableOpenGL(hwnd, &hDC, &hRC);

    Sleep (10);

    PlaySound(TEXT("esanssipolkka.wav"),NULL, SND_ASYNC|SND_FILENAME|SND_LOOP);
    float offsetx;
    float offsety;
    float speedy;
    float aaltox;
    float aaltoy;
    float speedx;
    float gravity = -0.01;
    float fric = 0.0001;
    clock_t start = clock(), diff;
    SetWindowPos(hwnd, HWND_TOP, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
    double t = 0;
    while (!bQuit)
    {

        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
        {

            if (msg.message == WM_QUIT)
            {
                bQuit = TRUE;
            }
            else
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }
        else
        {
            float i;
            float j;
            float x;
            float y;
            float v;
            float cx;
            float cy;


            //  glClearColor(sin(theta*4), sin(theta*5), sin(theta*8), 0.0f);
            glClear(GL_COLOR_BUFFER_BIT);

            glPushMatrix();

            glPointSize(10);
            glLineWidth(1);
            glEnable(GL_POINT_SMOOTH);
            glScaled( (float)WINh/(float)WINw, 1,0);
            if(t < 8)
            {
                //     glRotatef(theta*40, 0, 0.0f, 1.0f);
            }
            if(t > 8 && t < 12)
            {
                glRotatef(theta*40, 1, 0.0f, 1.0f);
            }


            if(t > 12 && t < 20)
            {

                glRotatef((theta-20)*140, 0.0f, 0.0f, 1.0f);

            }
            if(t > 20 && t < 40)
            {

                glRotatef((theta-20)*140, 1.0f, 1.0f, 1.0f);

            }
            else
            {
                glRotatef(0, 1.0f, 1.0f, 1.0f);
            }


            printf("%f.",t);
            printf("\n");

            glColor3f(1.0f,0.0f,0.0f);
            if(t < 8)
            {

                glBegin(GL_POINTS);

                for (x = 0; x < 100; x++)
                {
                    for(y = 0; y < 100; y++)
                    {
                        v = 0;

                        v = sin(x/6+theta)/2+0.5;
                        v += sin(x/6*sin(theta/2)+y/6*cos(theta/3)+theta)/2+0.5;
                        cx = x/40 + 1.5*sin(theta/5);
                        cy = y/40 + 1.5*cos(theta/3);
                        v += sin(sqrt(100*(cx*cx+cy*cy)+2+theta))/2+0.5;

                        if(t > 1.6 && t < 3.2 )
                        {
                            glColor3f(cos(v*PI),sin(v*PI),sin(v*PI+4*PI/3));

                        }

                        if(t > 3.2 )
                        {
                            glColor3f(sin(v*PI),sin(v*PI+4*PI/3),cos(v*PI));
                            j = sin(y/35)/6*sin(theta*10);
                            i = sin(x/35)/6*sin(theta*10);
                        }

                        if(t > 4.8 )
                        {
                            j = sin(y/35)/8*sin(theta*10);
                            i = sin(x/35)/8*sin(theta*10);
                        }
                        if(t > 7 )
                        {

                            offsetx += (x-50)/100000;
                            offsety += (y-50)/100000;

                        }
                              aaltox = sin(y/5+(float)theta)*0.1;
                        aaltoy =  sin(x/5+(float)theta)*0.1;

                        glVertex2d(x/50-1+j+offsetx+aaltox,y/50-1+i+offsety+aaltoy);

                    }
                }


                glEnd();

            }
//INIT PHYSIXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX!!!!!!


            if(t > 7 )
            {
                speedy += gravity;
                offsetx += speedx - fric ;
                offsety += speedy - fric;


            }




            glLineWidth(2);
            if(t > 8 && t < 12)
            {
                glColor3f(sin(t*9),sin(t*7),sin(t*11));
                for(i = 0; i <180; i++)
                {
                    glBegin(GL_LINES);
                    glVertex2d(sin(i*2*PI/180)*4+cos(t/2),cos(i*2*PI/180)*4);
                    glVertex2d(sin((i+45)*2*PI/180)*2+cos(t/2),0);
                    glEnd();
                }
                for(i = 0; i <180; i++)
                {
                    glBegin(GL_LINES);
                    glVertex2d(sin(i*2*PI/180)*2+sin(t/2),cos(i*2*PI/180)*2);
                    glVertex2d(0,cos((i+45)*2*PI/180)*2);
                    glEnd();
                }
            }

            if(t > 12 && t < 20)
            {
                glColor3f(sin(t*9),sin(t*7),sin(t*11));
                for (j = 1; j < 9; j++)
                {
                    for(i = 0; i <180; i++)
                    {
                        glBegin(GL_POINTS);
                        glVertex2d(sin(i*2*PI/180)*sin(theta/2*j),cos(i*2*PI/180)*cos(theta/2*j));
                        glEnd();
                    }
                }
            }

//THIS IS SO FUKKEN HARD!

            if(t > 20 && t < 40)
            {
                glColor3f(cos(t*1),sin(t*7),sin(t*11));
                for(j = 0; j < 50; j++)
                {
                    for(i = 0; i <90; i++)
                    {

                        glBegin(GL_POINTS);
                        glColor3f(cos(j)+1/2,1,0);
                        glVertex2d(sin(i*4*PI/180)*sin(j/40+theta/2)*2+sin(t/2),cos(i*4*PI/180)*sin(j/40+theta/2)*2);
                        glEnd();
                    }
                }

                for(j = 0; j < 50; j++)
                {
                    for(i = 0; i <90; i++)
                    {
                        glBegin(GL_POINTS);
                        glColor3f(cos(j)+1/2,0,1);
                        glVertex2d(sin(i*4*PI/180)*sin(j/40+theta/2)*2+cos(t/2),cos(i*4*PI/180)*sin(j/40+theta/2)*2);
                        glEnd();
                    }
                }


            }
//viimeist vied!

            if (t > 58)
            {

                glPointSize((t-58)*200+10);
            }
            if (t > 40)
            {
                for (y = 0; y < 10; y++)
                {
                    for(x = 0; x < 400; x++)
                    {
                        glBegin(GL_POINTS);
                        glColor3f(1,sin(x/17),sin(x/25));
                        glVertex2d(x/100-2,(sin(x/40)+sin(x/20+t*15)*sin(t)*0.5+y/10)*0.5-0.2);
                        glEnd();
                    }
                }
            }


            glPopMatrix();

            SwapBuffers(hDC);


            diff = clock() - start;
            int msec = diff * 1000 / CLOCKS_PER_SEC;

            theta = (float)msec/1000;
            t = (float)msec/1000;
            //   printf("%.2f",theta);
            //  printf("\n");
            Sleep (10);
            if(theta > 61 )
            {
                return 0;
            }
        }
    }


    DisableOpenGL(hwnd, hDC, hRC);


    DestroyWindow(hwnd);

    return msg.wParam;
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_CLOSE:
        PostQuitMessage(0);
        break;

    case WM_DESTROY:
        return 0;

    case WM_KEYDOWN:
    {
        switch (wParam)
        {
        case VK_ESCAPE:
            PostQuitMessage(0);
            break;
        }
    }
    break;

    default:
        return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }

    return 0;
}

void EnableOpenGL(HWND hwnd, HDC* hDC, HGLRC* hRC)
{
    PIXELFORMATDESCRIPTOR pfd;

    int iFormat;


    *hDC = GetDC(hwnd);


    ZeroMemory(&pfd, sizeof(pfd));

    pfd.nSize = sizeof(pfd);
    pfd.nVersion = 1;
    pfd.dwFlags = PFD_DRAW_TO_WINDOW |
                  PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
    pfd.iPixelType = PFD_TYPE_RGBA;
    pfd.cColorBits = 24;
    pfd.cDepthBits = 16;
    pfd.iLayerType = PFD_MAIN_PLANE;

    iFormat = ChoosePixelFormat(*hDC, &pfd);

    SetPixelFormat(*hDC, iFormat, &pfd);

    /* create and enable the render context (RC) */
    *hRC = wglCreateContext(*hDC);

    wglMakeCurrent(*hDC, *hRC);
}

void DisableOpenGL (HWND hwnd, HDC hDC, HGLRC hRC)
{
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hRC);
    ReleaseDC(hwnd, hDC);
}



